
[data] = xlsread('eeg_linealized_3-R3_ip.xlsx');

eeg = data(1:16384, 3)

fs = 128
%sample_length = length(eeg)/fs;
nfft = 512;
%window = hann(nfft);
noverlap = nfft * 0.5;

J = fix((length(eeg)-noverlap) / fs);
S = zeros(fs/2+1, J);


for jj = 1 : J
    y = eeg(1 + (jj-1) * fs : jj * fs)';
    
    ydft = fft(y) .* rectwin(fs)';
    
    YDFT = abs(ydft).^2/(nfft*fs); 
    YDFT = YDFT(1:length(ydft)/2+1);
    YDFT = 20*log10(YDFT); 
    S(:, jj) = YDFT;

end

F = 0 : (fs/2)/(nfft/8) : fs/2;
T = 1 : 1 : J ;

surf(T, F, S, 'EdgeColor', 'flat', 'FaceColor', 'interp', 'FaceLighting', 'none')
axis xy; axis tight; colormap(jet); view(2); colorbar;
xlabel('Time (sec)');
ylabel('Frequency (Hz)');

view(45,-65)