
[data] = xlsread('eeg_linealized_3-R3_ip.xlsx');

eeg = data(1:16384, 3);
nfft = 512;
fs = 128;
noverlap = nfft * 0.5;

J = fix((length(eeg)-noverlap) / fs);
S = zeros(fs/2+1, J);

for jj = 1 : J
     y = eeg(1 + (jj-1) * fs : jj * fs)';

    [e,v] = dpss(length(y),3.5,10);
    idx = find(v>0.99,1,'last');

    [pxx,f] = pmtm(y,e(:,1:idx),v(1:idx),length(y),fs,'DropLastTaper',false);
    
    YDFT = 20*log10(pxx);     
    S(:, jj) = YDFT;
end

F = 0 : (fs/2)/(nfft/8) : fs/2;
T = 0 : 1 : J-1 ;

surf(T, F, S, 'EdgeColor', 'flat', 'FaceColor', 'interp', 'FaceLighting', 'none')
axis xy; axis tight; colormap(jet); view(2); colorbar;
xlabel('Time (sec)');
ylabel('Frequency (Hz)');

view(45,-65)

