class Graph {
  float xdataMin = 0;
  float xdataMax = 0; 
  float ydataMax = 0;
  float ydataMin = 0; 
  float xvolumeInterval = 0;
  float yvolumeInterval = 0;
  float xvolumeIntervalMinor = 0;
  float yvolumeIntervalMinor = 0;   
  float plotX1 = 0; 
  float plotY1 = 0; 
  float plotX2 = 0;
  float plotY2 = 0; 
  float plotX_W = 0;
  float plotY_W = 0; 
  float labelX;
  float labelY;
  String xlabel = "x";
  String ylabel = "y";

  // Constructor
  Graph (float _xdataMin, float _xdataMax, float _ydataMin, float _ydataMax, 
    float _xvolumeInterval, float _yvolumeInterval, float _xvolumeIntervalMinor, float _yvolumeIntervalMinor, 
    float _plotX1, float _plotY1, float _plotX_W, float _plotY_W) {
    xdataMin = _xdataMin;
    xdataMax = _xdataMax;
    ydataMax = _ydataMax;
    ydataMin = _ydataMin;
    xvolumeInterval = _xvolumeInterval;
    yvolumeInterval = _yvolumeInterval;
    xvolumeIntervalMinor = _xvolumeIntervalMinor;
    yvolumeIntervalMinor = _yvolumeIntervalMinor;
    plotX1 = _plotX1;
    plotY1 = _plotY1;
    plotX2 = _plotX1+_plotX_W;
    plotY2 = _plotY1+_plotY_W;
    plotX_W = _plotX_W;
    plotY_W = _plotX_W;
  }

  void drawPoints(float _x[], float _y[], int _flag) {
    float[] xvalue = _x;
    float[] yvalue = _y;
    float x_mapped = 0;
    float y_mapped = 0;
    float x_mapped_pre = 0;
    float y_mapped_pre = 0;
    int flag = _flag;

    for (int i= 0; i<xvalue.length-1; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i], xdataMin, xdataMax, plotX1, plotX2); 
        y_mapped = map(yvalue[i], ydataMin, ydataMax, plotY2, plotY1); 
        if (xvalue[i] > 0  && xvalue[i] <=1024  && yvalue[i] >=-100 && yvalue[i] <= 100) {
          strokeWeight(1.5);
          stroke(#00ff00);

          if (i >0) {
            if (flag == 0) {
              strokeWeight(2.0);
              point(x_mapped, y_mapped);
            } else {
              line (x_mapped_pre, y_mapped_pre, x_mapped, y_mapped);
            }
          }
          x_mapped_pre = x_mapped;
          y_mapped_pre = y_mapped;
        }
      }
    }
  }

  void drawPoints0(float _x[], float _y1[], float _y2[], int _flag) {
    float[] xvalue = _x;
    float[] yvalue1 = _y1;
    float[] yvalue2 = _y2;
    float x_mapped = 0;
    float y_mapped = 0;
    float x_mapped_pre = plotX1;
    float y_mapped_pre = plotY1+(plotY2-plotY1)/2;
    int flag = _flag;


    for (int i= 0; i<yvalue1.length-1; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i], xdataMin, xdataMax, plotX1, plotX2); 
        y_mapped = map(yvalue1[i], ydataMin, ydataMax, plotY2, plotY1); 
        if (xvalue[i] > 0  && xvalue[i] <=1024  && yvalue1[i] >=-100 && yvalue1[i] <= 100) {
          strokeWeight(1.5);
          stroke(#00ff00);

          if (i >0) {
            if (flag == 0) {
              strokeWeight(1.5);
              point(x_mapped, y_mapped);
            } else {
              line (x_mapped_pre, y_mapped_pre, x_mapped, y_mapped);
            }
          }

          x_mapped_pre = x_mapped;
          y_mapped_pre = y_mapped;
        }
      }
    }
  }

  void drawPoints2(float _x[], float _y0[], float _y1[], float _y2[], float _y3[], float _y4[], float _y5[], int _flag) {
    float[] xvalue = _x;
    float[] yvalue0 = _y0;
    float[] yvalue1 = _y1;
    float[] yvalue2 = _y2;
    float[] yvalue3 = _y3;
    float[] yvalue4 = _y4;
    float[] yvalue5 = _y5;
    float x_mapped = 0;
    float y0_mapped = 0;
    float y1_mapped = 0;
    float y2_mapped = 0;
    float y3_mapped = 0;
    float y4_mapped = 0;
    float y5_mapped = 0;
    float x_mapped_pre = 0;
    float y0_mapped_pre = 0;
    float y1_mapped_pre = 0;
    float y2_mapped_pre = 0;
    float y3_mapped_pre = 0;
    float y4_mapped_pre = 0;
    float y5_mapped_pre = 0;
    int flag = _flag;

    for (int i= 0; i<xvalue.length; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i], xdataMin, xdataMax, plotX1, plotX2); 
        y0_mapped = map(yvalue0[i], ydataMin, ydataMax, plotY2, plotY1); 
        strokeWeight(2);
        stroke(#00ff00);
        if (i >0) {
          if (flag == 0) {
            point(x_mapped, y0_mapped);
          } else {
            line (x_mapped_pre, y0_mapped_pre, x_mapped, y0_mapped);
          }
        }
        x_mapped_pre = x_mapped;
        y0_mapped_pre = y0_mapped;
      }
    } 

    for (int i= 0; i<xvalue.length; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i], xdataMin, xdataMax, plotX1, plotX2); 
        y1_mapped = map(yvalue1[i], ydataMin, ydataMax, plotY2, plotY1); 
        strokeWeight(2);
        stroke(#FF00FF);
        if (i >0) {
          if (flag == 0) {
            point(x_mapped, y1_mapped);
          } else {
            line (x_mapped_pre, y1_mapped_pre, x_mapped, y1_mapped);
          }
        }
        x_mapped_pre = x_mapped;
        y1_mapped_pre = y1_mapped;
      }
    } 

    for (int i= 0; i<xvalue.length; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i], xdataMin, xdataMax, plotX1, plotX2); 
        y2_mapped = map(yvalue2[i], ydataMin, ydataMax, plotY2, plotY1); 
        strokeWeight(1.5);
        stroke(#00FFFF);
        if (i >0) {
          if (flag == 0) {
            point(x_mapped, y2_mapped);
          } else {
            line (x_mapped_pre, y2_mapped_pre, x_mapped, y2_mapped);
          }
        }
        x_mapped_pre = x_mapped;
        y2_mapped_pre = y2_mapped;
      }
    } 

    for (int i= 0; i<xvalue.length; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i], xdataMin, xdataMax, plotX1, plotX2); 
        y3_mapped = map(yvalue3[i], ydataMin, ydataMax, plotY2, plotY1); 
        strokeWeight(1.5);
        stroke(#FFA500);
        if (i >0) {
          if (flag == 0) {
            point(x_mapped, y3_mapped);
          } else {
            line (x_mapped_pre, y3_mapped_pre, x_mapped, y3_mapped);
          }
        }
        x_mapped_pre = x_mapped;
        y3_mapped_pre = y3_mapped;
      }
    } 

    for (int i= 0; i<xvalue.length; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i], xdataMin, xdataMax, plotX1, plotX2); 
        y4_mapped = map(yvalue4[i], ydataMin, ydataMax, plotY2, plotY1); 
        strokeWeight(1.5);
        stroke(#FFFF00);
        if (i >0) {
          if (flag == 0) {
            point(x_mapped, y4_mapped);
          } else {
            line (x_mapped_pre, y4_mapped_pre, x_mapped, y4_mapped);
          }
        }
        x_mapped_pre = x_mapped;
        y4_mapped_pre = y4_mapped;
      }
    } 

    for (int i= 0; i<xvalue.length; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i], xdataMin, xdataMax, plotX1, plotX2); 
        y5_mapped = map(yvalue5[i], ydataMin, ydataMax, plotY2, plotY1); 
        strokeWeight(1.5);
        stroke(#FF0800);
        if (i >0) {
          if (flag == 0) {
            point(x_mapped, y5_mapped);
          } else {
            line (x_mapped_pre, y5_mapped_pre, x_mapped, y5_mapped);
          }
        }
        x_mapped_pre = x_mapped;
        y5_mapped_pre = y5_mapped;
      }
    }
  }

  void drawPoints3(float _x[], float _y[], int _flag, int _color_code) {
    float[] xvalue = _x;
    float[] yvalue = _y;
    float x_mapped = 0;
    float y_mapped = 0;
    float x_mapped_pre = 0;
    float y_mapped_pre = 0;
    int flag = _flag;
    int color_code = _color_code;

    for (int i= 0; i<xvalue.length-1; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i], xdataMin, xdataMax, plotX1, plotX2); 
        y_mapped = map(yvalue[i], ydataMin, ydataMax, plotY2, plotY1); 
        if (xvalue[i] >= -50  && xvalue[i] <= 50 && yvalue[i] >= -50 && yvalue[i] <= 50) {
          strokeWeight(1.0);

          switch (color_code) {
          case 0:  
            stroke(#00ff00);
            break;
          case 1:  
            stroke(#FF00FF);
            break;
          case 2:  
            stroke(#00FFFF);
            break;
          case 3:  
            stroke(#FFA500);
            break;
          case 4:  
            stroke(#FFFF00);
            break;
          case 5:  
            stroke(#FF0800);
            break;
          }

          if (i > 0) {
            if (flag == 0) {
              point(x_mapped, y_mapped);
            } else {
              line (x_mapped_pre, y_mapped_pre, x_mapped, y_mapped);
            }
          }
          x_mapped_pre = x_mapped;
          y_mapped_pre = y_mapped;
        }
      }
    }
  }

  void drawPoints4(float[] _xvalue, float[] _yvalue, int _color_code ) { 
    float xvalue;
    float yvalue;
    float x_mapped = 0;
    float y_mapped = 0;
    int col=0; 
    int color_code = _color_code;

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue = _yvalue[i];
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue, ydataMin, ydataMax, plotY2, plotY1); 
      switch (color_code) {
      case 0:  
        stroke(#00ff00);
        break;
      case 1:  
        stroke(#FF00FF);
        break;
      case 2:  
        stroke(#00FFFF);
        break;
      case 3:  
        stroke(#FFA500);
        break;
      case 4:  
        stroke(#FFFF00);
        break;
      case 5:  
        stroke(#FF0800);
        break;
      }
      strokeWeight(1.5); 
      point(x_mapped, y_mapped);
    }
    xvalue = _xvalue[0];
    yvalue = _yvalue[0];
    x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
    y_mapped = map(yvalue, ydataMin, ydataMax, plotY2, plotY1);
    if (_color_code == 0) {
      stroke(#ff0000);
    } else { 
      stroke(#00ff00);
    }
    strokeWeight(6);
    point(x_mapped, y_mapped);
  }    

  void drawPoints5(float _x[], float _y[], int _flag) {
    float[] xvalue = _x;
    float[] yvalue = _y;
    float x_mapped = 0;
    float y_mapped = 0;
    float x_mapped_pre = 0;
    float y_mapped_pre = 0;
    int flag = _flag;

    hour = hour();
    min = minute();
    sec = second();
    time_now = hour + "-" + nf(min, 2) + "-" + nf(sec, 2);


    for (int i= 0; i<xvalue.length-1; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i]-t_start/1000, xdataMin, xdataMax, plotX1, plotX2); 
        y_mapped = map(yvalue[i], ydataMin, ydataMax, plotY2, plotY1); 
        if (xvalue[i] > 0) {
          strokeWeight(1);
          stroke(#00ff00);
          if (i >0) {
            if (flag == 0) {
              point(x_mapped, y_mapped);
            } else {
              if (x_mapped_pre > 0 && y_mapped_pre > 0  && x_mapped > 0 && y_mapped >0)
              {
              line (x_mapped_pre, y_mapped_pre, x_mapped, y_mapped);
              }
            }
          }
          x_mapped_pre = x_mapped;
          y_mapped_pre = y_mapped;
        }
      }
    }
  }

  void drawPoints52(float _x[], float _y[], int _flag) {
    float[] xvalue = _x;
    float[] yvalue = _y;
    float x_mapped = 0;
    float y_mapped = 0;
    float x_mapped_pre = 0;
    float y_mapped_pre = 0;
    int flag = _flag;

    hour = hour();
    min = minute();
    sec = second();
    time_now = hour + "-" + nf(min, 2) + "-" + nf(sec, 2);

    for (int i= 0; i<xvalue.length-1; i++) {
      if (xvalue[i] <= xdataMax) {
        x_mapped = map(xvalue[i]-t_start/1000, xdataMin, xdataMax, plotX1, plotX2); 
        y_mapped = map(yvalue[i], ydataMin, ydataMax, plotY2, plotY1); 
        if (xvalue[i] > 0  && xvalue[i] <=1024) {
          strokeWeight(1);
          stroke(#FF0800);
          if (i >0) {
            if (flag == 0) {
              point(x_mapped, y_mapped);
            } else {
              line (x_mapped_pre, y_mapped_pre, x_mapped, y_mapped);
            }
          }
          x_mapped_pre = x_mapped;
          y_mapped_pre = y_mapped;
        }
      }
    }
  }

  void drawPoints6(float[] _xvalue, float[] _yvalue0, float[] _yvalue1, float[] _yvalue2, float[] _yvalue3, float[] _yvalue4, float[] _yvalue5) { 
    float xvalue;
    float yvalue0;
    float yvalue1;
    float yvalue2;
    float yvalue3;
    float yvalue4;
    float yvalue5;
    float x_mapped = 0;
    float y_mapped = 0;

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue5 = _yvalue5[i];
      if (yvalue5 > ydataMax) {
        yvalue5 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue5, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue5 >= ydataMin  && yvalue5 <= ydataMax) {
        stroke(#FF0800);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue4 = _yvalue4[i];
      if (yvalue4 > ydataMax) {
        yvalue4 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue4, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue4 >= ydataMin  && yvalue4 <= ydataMax) {
        stroke(#FFFF00);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue3 = _yvalue3[i];
      if (yvalue3 > ydataMax) {
        yvalue3 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue3, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue3 >= ydataMin  && yvalue3 <= ydataMax) {
        stroke(#FFA500);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }
    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue2 = _yvalue2[i];
      if (yvalue2 > ydataMax) {
        yvalue2 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue2, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue2 >= ydataMin  && yvalue2 <= ydataMax) {
        stroke(#00FFFF);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue1 = _yvalue1[i];
      if (yvalue1 > ydataMax) {
        yvalue1 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue1, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue1 >= ydataMin  && yvalue1 <= ydataMax) {
        stroke(#FF00FF);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue0 = _yvalue0[i];
      if (yvalue0 > ydataMax) {
        yvalue0 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue0, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue0 >= ydataMin  && yvalue0 <= ydataMax) {
        stroke(#00FF00);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }
  }    

  void drawPoints6R(float[] _xvalue, float[] _yvalue1, float[] _yvalue2, float[] _yvalue3, float[] _yvalue4, float[] _yvalue5) { 
    float xvalue;
    float yvalue1;
    float yvalue2;
    float yvalue3;
    float yvalue4;
    float yvalue5;
    float x_mapped = 0;
    float y_mapped = 0;

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue5 = _yvalue5[i];
      if (yvalue5 > ydataMax) {
        yvalue5 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue5, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue5 >= ydataMin  && yvalue5 <= ydataMax) {
        stroke(#FF0800);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue4 = _yvalue4[i];
      if (yvalue4 > ydataMax) {
        yvalue4 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue4, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue4 >= ydataMin  && yvalue4 <= ydataMax) {
        stroke(#FFFF00);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue3 = _yvalue3[i];
      if (yvalue3 > ydataMax) {
        yvalue3 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue3, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue3 >= ydataMin  && yvalue3 <= ydataMax) {
        stroke(#FFA500);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }
    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue2 = _yvalue2[i];
      if (yvalue2 > ydataMax) {
        yvalue2 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue2, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue2 >= ydataMin  && yvalue2 <= ydataMax) {
        stroke(#00FFFF);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }

    for (int i = 1; i < trend_point; i++) { 
      xvalue = _xvalue[i];
      yvalue1 = _yvalue1[i];
      if (yvalue1 > ydataMax) {
        yvalue1 = ydataMax;
      }
      x_mapped = map(xvalue, xdataMin, xdataMax, plotX1, plotX2); 
      y_mapped = map(yvalue1, ydataMin, ydataMax, plotY2, plotY1); 
      if (xvalue >=xdataMin && yvalue1 >= ydataMin  && yvalue1 <= ydataMax) {
        stroke(#FF00FF);
        strokeWeight(1); 
        point(x_mapped, y_mapped);
      }
    }
  }    

  //Unused: for 3D graph 
  void drawPoints7(double _x[][]) {
    float zvalue = 0;
    float x_mapped = 0;
    float y_mapped = 0;

    float _maxRange = 1;
    for (int j = 0; j <94; j++) {
      for (int i = 0; i <94; i++) {
        _maxRange = (abs((float) _x[j][i]) > _maxRange ? abs((float) _x[j][i]) : _maxRange);
      }
    }

    for (int j=2; j<47; j++) {
      for (int i=1; i<j; i++) {
        x_mapped = map(j, xdataMin, xdataMax, plotX1, plotX2); 
        y_mapped = map(i, ydataMin, ydataMax, plotY2, plotY1); 
        zvalue = (float) _x[j][i]/_maxRange;

        strokeWeight(4);
        stroke(int(zvalue*2550), 100, 100);
        if (i >0) {      
          point(x_mapped, y_mapped);
        }
      }
    }

    for (int j=47; j<94; j++) {
      for (int i=1; i<94-j; i++) {
        x_mapped = map(j, xdataMin, xdataMax, plotX1, plotX2); 
        y_mapped = map(i, ydataMin, ydataMax, plotY2, plotY1); 
        zvalue = (float) _x[j][i]/_maxRange;

        strokeWeight(4);
        stroke(int(zvalue*2550), 100, 100);
        if (i >0) { 
          point(x_mapped, y_mapped);
        }
      }
    }
  }

  void xdrawVolumeLabels() {
    fill(0);
    textSize(10);
    textAlign(RIGHT);  
    stroke(128);
    strokeWeight(1.0);

    for (float v = xdataMin; v <= xdataMax; v += xvolumeIntervalMinor) {
      if (v % xvolumeIntervalMinor == 0) {     // If a tick mark
        float x = map(v, xdataMax, xdataMin, plotX2, plotX1);  
        if (v % xvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == xdataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == xdataMax) {
            textOffset = textAscent();        // Align by the top
          }
          text(floor(v), x + textOffset, plotY2 + 15);
          line(x, plotY2 + 4, x, plotY2);     // Draw major tick
        } else {
          line(x, plotY2 + 2, x, plotY2);     // Draw minor tick
        }
      }
    }
  }

  void xdrawVolumeLabels0() {
    fill(0);
    textSize(10);
    textAlign(RIGHT);  
    stroke(128);
    strokeWeight(1.0);

    for (float v = xdataMin; v <= xdataMax; v += xvolumeIntervalMinor) {
      if (v % xvolumeIntervalMinor == 0) {     // If a tick mark
        float x = map(v, xdataMax, xdataMin, plotX2, plotX1);  
        if (v % xvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == xdataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == xdataMax) {
            textOffset = textAscent();        // Align by the top
          }
          text(floor(v/128), x + textOffset, plotY2 + 15);
          line(x, plotY2 + 4, x, plotY2);     // Draw major tick
        } else {
          line(x, plotY2 + 2, x, plotY2);     // Draw minor tick
        }
      }
    }
  }

  void xdrawVolumeLabels2() {
    fill(0);
    textSize(10);
    textAlign(RIGHT);  
    stroke(128);
    strokeWeight(0.5);
    //rect(plotX1, plotY1, plotX2, plotY2); 

    for (float v = xdataMin; v <= xdataMax; v += xvolumeIntervalMinor) {
      if (v % xvolumeIntervalMinor == 0) {     // If a tick mark
        float x = map(v, xdataMax, xdataMin, plotX2, plotX1);  
        if (v % xvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == xdataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == xdataMax) {
            textOffset = textAscent();        // Align by the top
          }
          text(floor(v)/60 + trend_loop_cnt*trend_point/3/60, x + textOffset, plotY2 + 20);
          line(x, plotY2 + 4, x, plotY2);     // Draw major tick
        } else {
          line(x, plotY2 + 2, x, plotY2);     // Draw minor tick
        }
      }
    }
  }


  void xdrawVolumeLabels3() {
    fill(0);
    textSize(10);
    textAlign(RIGHT);  
    stroke(128);
    strokeWeight(0.5);
    //rect(plotX1, plotY1, plotX2, plotY2); 

    for (float v = xdataMin; v <= xdataMax; v += xvolumeIntervalMinor) {
      if (v % xvolumeIntervalMinor == 0) {     // If a tick mark
        float x = map(v, xdataMax, xdataMin, plotX2, plotX1);  
        if (v % xvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == xdataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == xdataMax) {
            textOffset = textAscent();        // Align by the top
          }
          text(nf(v/100, 1, 1), x + textOffset, plotY2 + 10);
          line(x, plotY2 + 4, x, plotY2);     // Draw major tick
        } else {
          line(x, plotY2 + 2, x, plotY2);     // Draw minor tick
        }
      }
    }
  }

  void ydrawVolumeLabels() {
    fill(0);
    textSize(10);
    textAlign(RIGHT);  
    stroke(128);
    strokeWeight(1.0);
    rect(plotX1, plotY1, plotX2, plotY2); 

    for (float v = ydataMin; v <= ydataMax; v += yvolumeIntervalMinor) {
      if (v % yvolumeIntervalMinor == 0) {     // If a tick mark
        float y = map(v, ydataMin, ydataMax, plotY2, plotY1);  
        if (v % yvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == ydataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == ydataMax) {
            textOffset = textAscent();        // Align by the top
          }
          text(floor(v), plotX1 - 10, y + textOffset);
          line(plotX1 - 4, y, plotX1, y);     // Draw major tick
        } else {
          line(plotX1 - 2, y, plotX1, y);     // Draw minor tick
        }
      }
    }
  }

  void ydrawVolumeLabels1() {
    fill(0);
    textSize(10);
    textAlign(RIGHT);  
    stroke(128);
    strokeWeight(1.0);
    rect(plotX1, plotY1, plotX2, plotY2); 

    for (float v = ydataMin; v <= ydataMax; v += yvolumeIntervalMinor) {
      if (v % yvolumeIntervalMinor == 0) {     // If a tick mark
        float y = map(v, ydataMin, ydataMax, plotY2, plotY1);  
        if (v % yvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == ydataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == ydataMax) {
            textOffset = textAscent();        // Align by the top
          }
          text(nf(v,1,1), plotX1 - 10, y + textOffset);
          line(plotX1 - 4, y, plotX1, y);     // Draw major tick
        } else {
          line(plotX1 - 2, y, plotX1, y);     // Draw minor tick
        }
      }
    }
  }

  void ydrawVolumeLabels2() {
    fill(0);
    textSize(10);
    textAlign(RIGHT);  
    stroke(128);
    strokeWeight(0.5);
    rect(plotX1, plotY1, plotX2, plotY2); 

    for (float v = ydataMin; v <= ydataMax; v += yvolumeIntervalMinor) {
      if (v % yvolumeIntervalMinor == 0) {     // If a tick mark
        float y = map(v, ydataMin, ydataMax, plotY2, plotY1);  
        if (v % yvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == ydataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == ydataMax) {
            textOffset = textAscent();        // Align by the top
          }
          text(nf(v/100, 1, 2), plotX1 - 10, y + textOffset);
          line(plotX1 - 4, y, plotX1, y);     // Draw major tick
        } else {
          line(plotX1 - 2, y, plotX1, y);     // Draw minor tick
        }
      }
    }
  }

  void drawxLabels() {
    fill(0);
    stroke(224);
    strokeWeight(0.5);

    for (float v = xdataMin; v <= xdataMax; v += xvolumeIntervalMinor) {
      if (v % xvolumeIntervalMinor == 0) {     // If a tick mark
        float x = map(v, xdataMax, xdataMin, plotX2, plotX1);  
        if (v % xvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == xdataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == xdataMax) {
            textOffset = textAscent();        // Align by the top
          }
          line(x, plotY1, x, plotY2);     // Draw major tick
        }
      }
    }
  }

  void drawyLabels() {
    fill(0);
    stroke(224);
    strokeWeight(0.5);

    for (float v = ydataMin; v <= ydataMax; v += yvolumeIntervalMinor) {
      if (v % yvolumeIntervalMinor == 0) {     // If a tick mark
        float y = map(v, ydataMin, ydataMax, plotY2, plotY1);  
        if (v % yvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == ydataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == ydataMax) {
            textOffset = textAscent();        // Align by the top
          }
          line(plotX1, y, plotX2, y);     // Draw major tick
        }
      }
    }
  }

  void drawAxisLabels(String _ylabel, String _xlabel) {
    fill(0);
    noStroke();
    rect(plotX1, plotY1, plotX2, plotY2);
    String xlabel = _xlabel;
    String ylabel = _ylabel;
    labelX = plotX1-30;
    labelY = plotY2+25;

    fill(0);
    textSize(14);
    textLeading(15);  
    textAlign(CENTER, CENTER);
    text(xlabel, labelX, (plotY1+plotY2)/2);
    textAlign(CENTER);
    text(ylabel, (plotX1+plotX2)/2, labelY);
  }

  void drawAxisLabels2(String _ylabel, String _xlabel) {
    fill(0);
    noStroke();
    rect(plotX1, plotY1, plotX2, plotY2);
    String xlabel = _xlabel;
    String ylabel = _ylabel;
    labelX = plotX1-50;
    labelY = plotY2+30;

    fill(0);
    textSize(14);
    textLeading(15);  
    textAlign(CENTER, CENTER);
    text(xlabel, labelX, (plotY1+plotY2)/2);
    textAlign(CENTER);
    text(ylabel, (plotX1+plotX2)/2, labelY);
  }

  void drawAxisLabels3(String _ylabel, String _xlabel) {
    fill(0);
    noStroke();
    rect(plotX1, plotY1, plotX2, plotY2);
    String xlabel = _xlabel;
    String ylabel = _ylabel;
    labelX = plotX1-35;
    labelY = plotY2+35;

    fill(0);
    textSize(14);
    textLeading(15);  
    textAlign(CENTER, RIGHT);
    text(xlabel, labelX, (plotY1+plotY2)/2);
    textAlign(CENTER);
    text(ylabel, (plotX1+plotX2)/2, labelY);
  }

  void drawAxisLabels4(String _ylabel, String _xlabel) {
    fill(0);
    noStroke();
    rect(plotX1, plotY1, plotX2, plotY2);
    String xlabel = _xlabel;
    String ylabel = _ylabel;
    labelX = plotX1-65;
    labelY = plotY2+35;

    fill(0);
    textSize(14);
    textLeading(15);  
    textAlign(CENTER, RIGHT);
    text(xlabel, labelX, (plotY1+plotY2)/2);
    textAlign(CENTER);
    text(ylabel, (plotX1+plotX2)/2, labelY);
  }
}

class graphMonitor {
  String TITLE;
  int X_POSITION, Y_POSITION;
  int X_LENGTH, Y_LENGTH;
  float [] y1;
  float maxRange;
  graphMonitor(String _TITLE, int _X_POSITION, int _Y_POSITION, int _X_LENGTH, int _Y_LENGTH) {
    TITLE = _TITLE;
    X_POSITION = _X_POSITION;
    Y_POSITION = _Y_POSITION;
    X_LENGTH   = _X_LENGTH;
    Y_LENGTH   = _Y_LENGTH;
    y1 = new float[X_LENGTH];

    for (int i = 0; i < X_LENGTH; i++) {
      y1[i] = 0;
    }
  }

  void graphDraw(float _y1) {

    y1[X_LENGTH - 1] = _y1;
    for (int i = 0; i < X_LENGTH - 1; i++) {
      y1[i] = y1[i + 1];
    }

    maxRange = 1;

    for (int i = 0; i < X_LENGTH - 1; i++) {
      maxRange = (abs(y1[i]) > maxRange ? abs(y1[i]) : maxRange);
    }

    pushMatrix();

    translate(X_POSITION, Y_POSITION);
    //fill(240);
    stroke(130);
    strokeWeight(1);
    rect(0, 0, X_LENGTH, Y_LENGTH);
    line(0, Y_LENGTH / 2, X_LENGTH, Y_LENGTH / 2);

    textSize(25);
    //fill(60);
    textAlign(LEFT, BOTTOM);
    //text(TITLE, 20, -5);
    textSize(12);
    textAlign(RIGHT);
    text(0, -5, Y_LENGTH / 2 + 7);
    text(nf(maxRange, 0, 1), -5, 10);
    text(nf(-1 * maxRange, 0, 1), -5, Y_LENGTH);

    translate(X_LENGTH, Y_LENGTH / 2);
    scale(-1, 1);
    strokeWeight(1.5);
    for (int i = 0; i < X_LENGTH - 1; i++) {
      stroke(#00ff00);
      line(i, y1[i] * (Y_LENGTH / 2) / maxRange, i + 1, y1[i + 1] * (Y_LENGTH / 2) / maxRange);
    }
    popMatrix();
  }
}

class BarGraph {
  float bar_xdataMin = 0;
  float bar_xdataMax = 0; 
  float bar_xvolumeInterval = 0;
  float bar_xvolumeIntervalMinor = 0;
  float bar_plotX1 = 0; 
  float bar_plotY1 = 0; 
  float bar_plotX2 = 0;
  float bar_plotY2 = 0; 

  // Constructor
  BarGraph (float _bar_xdataMin, float _bar_xdataMax, float _bar_xvolumeInterval, float _bar_xvolumeIntervalMinor, 
    float _bar_plotX1, float _bar_plotY1, float _bar_plotX_W, float _bar_plotY_W) {
    bar_xdataMin = _bar_xdataMin;
    bar_xdataMax = _bar_xdataMax;
    bar_xvolumeInterval = _bar_xvolumeInterval;
    bar_xvolumeIntervalMinor = _bar_xvolumeIntervalMinor;
    bar_plotX1 = _bar_plotX1;
    bar_plotY1 = _bar_plotY1;
    bar_plotX2 = _bar_plotX1+_bar_plotX_W;
    bar_plotY2 = _bar_plotY1+_bar_plotY_W;
  }

  void bar_draw(float _data, int _divisor, float _index) {

    colorMode(HSB);

    for (int i = 0; i <= 200; i++) {
      if (i <_data*_index) {  
        int c = 255 * i / 200;
        stroke(200-c, 200, 200);
        line(bar_plotX1+i, bar_plotY2-1, bar_plotX1+i, bar_plotY1+1);
      }
    }
    fill(0);
    textSize(13);
    textLeading(15);
    textAlign(LEFT, CENTER);
    text(int(_data/_divisor), bar_plotX2+5, bar_plotY1+10);

    if (_data >=900) {
      image(img1, bar_plotX1-25, bar_plotY1+3);
    } else if (_data >= 800 & _data < 900) {
      image(img2, bar_plotX1-25, bar_plotY1+3);
    } else if (_data >= 700 & _data <= 800) {
      image(img3, bar_plotX1-25, bar_plotY1+3);
    } else if (_data >= 600 & _data <= 700) {
      image(img4, bar_plotX1-25, bar_plotY1+3);
    } else if (_data >= 500 & _data <= 600) {
      image(img5, bar_plotX1-25, bar_plotY1+3);
    } else if (_data >= 400 & _data <= 500) {
      image(img6, bar_plotX1-25, bar_plotY1+3);
    } else if (_data >= 300 & _data <= 400) {
      image(img7, bar_plotX1-25, bar_plotY1+3);
    } else if (_data <= 300) {
      image(img8, bar_plotX1-25, bar_plotY1+3);
    } else {
      image(img9, bar_plotX1-25, bar_plotY1+3);
    }
  }

  void bar_xdrawVolumeLabels(int _divisor) {
    fill(0);
    textSize(8);
    textAlign(RIGHT);  
    stroke(128);
    strokeWeight(1);

    for (float v = bar_xdataMin; v <= bar_xdataMax; v += bar_xvolumeInterval) {
      if (v % bar_xvolumeInterval == 0) {     // If a tick mark
        float x = map(v, bar_xdataMin, bar_xdataMax, bar_plotX1, bar_plotX2);  
        if (v % bar_xvolumeInterval == 0) {        // If a major tick mark
          float textOffset = textAscent()/2;  // Center vertically
          if (v == bar_xdataMin) {
            textOffset = 0;                   // Align by the bottom
          } else if (v == bar_xdataMax) {
            textOffset = textAscent();        // Align by the top
          }
          text(floor(v)/_divisor, x + textOffset, bar_plotY2 + 16);
          line(x, bar_plotY2, x, bar_plotY2+4);     // Draw major tick
        } else {
          line(x, bar_plotY1 + 2, x, bar_plotY1 + 6);     // Draw minor tick
        }
      }
    }
  }

  void bar_drawxLabels() {
    fill(0);
    stroke(0);
    strokeWeight(1);

    for (float v = bar_xdataMin; v <= bar_xdataMax; v += bar_xvolumeIntervalMinor) {
      if (v % bar_xvolumeIntervalMinor == 0) {     // If a tick mark
        float x = map(v, bar_xdataMin, bar_xdataMax, bar_plotX1, bar_plotX2);  
        if (v % bar_xvolumeInterval == 0) {        // If a major tick mark
          if (v == bar_xdataMin) {
          } else if (v == bar_xdataMax) {
          }
          line(x, bar_plotY2+2, x, bar_plotY2+6);     // Draw major tick
        }
      }
    }
  }

  void backBar() {
    fill(#D8D8D8);
    noStroke();
    rect(bar_plotX1, bar_plotY1, bar_plotX2, bar_plotY2);
  } 

  void barLabels(String _label) {
    fill(0);
    textSize(13);
    textLeading(15);

    textAlign(CENTER, CENTER);
    text(_label, bar_plotX1-60, bar_plotY1+10);
    textAlign(CENTER, CENTER);
  }
}
